Subject: bug#48819: ‘chicken-build-system’ is not able to deal with specific version of egg

From: Xinglu Chen <[email-masked]>
Date: Thu, 03 Jun 2021 23:24:46 +0200

I am trying to package ‘chicken-begin-syntax’, it requires version 0.2.1
of ‘module-declarations’, which I have created a Guix package for (only
exists on my local branch).  However, when compiling
‘chicken-begin-syntax’, ‘chicken-install’ complains about an outdated
version of ‘module-declarations’, even though it’s not outdated.

Removing this restriction makes it build.

The content of ‘begin-syntax.egg’:

--8<---------------cut here---------------start------------->8---
((synopsis "Convenience macro for inline syntax expansion")
 (author "Evan Hanson")
 (license "BSD")
 (category lang-exts)
 (dependencies matchable)
 (test-dependencies srfi-1)
 (build-dependencies (module-declarations "0.2.1"))
 (components (extension begin-syntax (csc-options "-X" "module-declarations"))))
--8<---------------cut here---------------end--------------->8---

Build error message:

--8<---------------cut here---------------start------------->8---
starting phase `build'
The following installed extensions are outdated, because `begin-syntax' requires later versions:

  module-declarations (0.0.0 -> 0.2.1)

Do you want to replace the existing extensions? (yes/no/abort) 
Error: (string->list) bad argument type - not a string: #!eof
command "chicken-install" "-cached" "-no-install" "begin-syntax" failed with status 70
note: keeping build directory `/tmp/guix-build-chicken-begin-syntax-0.2.1.drv-0'
builder for `/gnu/store/gw8w10whrz9vmiaqhj5p9a8kwzd37pcp-chicken-begin-syntax-0.2.1.drv' failed with exit code 1
build of /gnu/store/gw8w10whrz9vmiaqhj5p9a8kwzd37pcp-chicken-begin-syntax-0.2.1.drv failed
View build log at '/var/log/guix/drvs/gw/8w10whrz9vmiaqhj5p9a8kwzd37pcp-chicken-begin-syntax-0.2.1.drv.bz2'.
cannot build derivation `/gnu/store/9lfv9h6ra9g5adw9ppdd1yf2r3z1bcc2-chicken-sourcehut-0.3.3.drv': 1 dependencies couldn't be built
guix build: error: build of `/gnu/store/9lfv9h6ra9g5adw9ppdd1yf2r3z1bcc2-chicken-sourcehut-0.3.3.drv' failed
--8<---------------cut here---------------end--------------->8---

I also tried passing the ‘-force’ and ‘-verbose’ flags to
‘chicken-install’, now it complains about ‘module-declarations’ not
being cached.   ¯\_(ツ)_/¯

--8<---------------cut here---------------start------------->8---
starting phase `build'
begin-syntax located at /tmp/guix-build-chicken-begin-syntax-0.2.1.drv-0/begin-syntax
checking begin-syntax ...
checking platform for `begin-syntax'
checking dependencies for `begin-syntax'
 upgrade: module-declarations
module-declarations not cached

Error: extension not cached
command "chicken-install" "-cached" "-no-install" "-force" "-verbose" "begin-syntax" failed with status 70
note: keeping build directory `/tmp/guix-build-chicken-begin-syntax-0.2.1.drv-6'
builder for `/gnu/store/87d8vdmsbmw5nl163j4x10km82swxash-chicken-begin-syntax-0.2.1.drv' failed with exit code 1
build of /gnu/store/87d8vdmsbmw5nl163j4x10km82swxash-chicken-begin-syntax-0.2.1.drv failed
View build log at '/var/log/guix/drvs/87/d8vdmsbmw5nl163j4x10km82swxash-chicken-begin-syntax-0.2.1.drv.bz2'.
guix build: error: build of `/gnu/store/87d8vdmsbmw5nl163j4x10km82swxash-chicken-begin-syntax-0.2.1.drv' failed
--8<---------------cut here---------------end--------------->8---